#ifndef	ALL_H
#define ALL_H

#include "config.h"
#include "xdata.h"

#define FU	0x20
#define KYOSHA	0x21
#define KEIMA	0x22
#define GIN	0x23
#define KIN	0x24
#define KAKU	0x25
#define HISHA	0x26
#define OU	0x27

#define	TuPromotionMask	0x08
#define	TuSideMask	0x10

#define TO	(FU	| TuPromotionMask)
#define NKYO	(KYOSHA	| TuPromotionMask)
#define NKEI	(KEIMA	| TuPromotionMask)
#define NGIN	(GIN	| TuPromotionMask)
#define UMA	(KAKU	| TuPromotionMask)
#define RYU	(HISHA	| TuPromotionMask)

#define	TuKomaMask	0x1F
#define	TuMyKomaMask	0x0F
#define	TuRawKomaMask	0x07

#define EMPTY 0

#define WIN_WIDTH 670
#define WIN_HEIGHT 600

#define KOMAGC0 8
#define KOMAGC1 9

#define SENTE 0
#define GOTE 1

#define CTRL_MAX 256

#define BUFFLEN 256

#define FROM_DAI		(-1)

typedef	enum {
	MAIN,
	GAME,
	VIEWGAME,
	VIEWNOTATION
} majormode_t;

extern Xdata xdata;
extern Windata win;
extern GCSet gcset;
extern Pixmap komapm[32];
extern const char *komaname[ ];
extern const char *komaname_j[ ];
extern char name[2][BUFFLEN];
extern char address[2][BUFFLEN];
extern int side;
extern int bell;
extern int auto_raise;
extern unsigned long debug;
extern majormode_t majormode;
extern char *myname;

/* debugging staff */
#define	ifDebug(c) if( debug & (1 << (c - '@')) )
#define	Debugging(c) (debug & (1 << (c - '@')))
#define	DebuggingNetwork	Debugging('N')
#define	DebuggingProtocol	Debugging('P')
#define	DebuggingXlib		Debugging('X')

#ifndef	STRCPY
/*
 * String copy macro.
 * In inside loop, do-while loop makes GCC (version 2.7.2.2, i386) generate
 * more simple (and probably faster) code than while loop.
 */
#define	STRCPY(pointer, source) \
	do {\
		register const char *_tmp_ = (source);\
		do { } while( (*(pointer)++ = *_tmp_++) );\
		(pointer)--;\
	} while(0)
#endif

#endif
