#if !defined(BAN_H)
#define BAN_H

#include "xtool.h"

#define KOMA_WIDTH		33
#define KOMA_HEIGHT		36

#define KOMA_OFFSET		2
#define MASU_WIDTH		(KOMA_WIDTH + KOMA_OFFSET * 2)
#define MASU_HEIGHT		(KOMA_HEIGHT + KOMA_OFFSET * 2)

#define BAN_OFFSET		16
#define BAN_WIDTH		(MASU_WIDTH * 9 + BAN_OFFSET * 2)
#define BAN_HEIGHT		(MASU_HEIGHT * 9 + BAN_OFFSET * 2)

#define DAI_OFFSET		16
#define DAI_WIDTH		112
#define DAI_HEIGHT		(MASU_HEIGHT * 7 + DAI_OFFSET * 2)

#define LIFE_WIDTH		200
#define LIFE_HEIGHT		150

#define CTRL_WIDTH		128
#define CTRL_HEIGHT		64

#define CTRL_MODE_TOP           0    /* for MapCtrl() */
#define CTRL_MODE_MID           1
#define CTRL_MODE_BOTTOM        2
#define CTRL_MODE_NONE          3

#define MY_SIDE			1
#define OPPONENT_SIDE		2
#define BOTH_SIDE		3

typedef struct
{
	Windata win;
	Pixmap pm, disppm;
	unsigned char data[9][9];
} Ban;

typedef struct
{
	Windata win;
	Pixmap pm, disppm;
	unsigned char data[2][8];
} Dai;

typedef struct
{
	Windata win;
	int life[2];
} Life;

typedef struct
{
	Windata win;
	Button top, next, prev, bottom;
} Ctrl;

typedef struct
{
	signed char	x, y;
	unsigned char	type;
} Pos;

void CreateBan(int x, int y, int init_mode, Ban *ban);
void DrawBan(Ban *ban, Pos pos, int mode);	/* mode != 0 : draw rect */
void ExposeBan(Ban *ban);
void MapBan(Ban *ban);

void DrawSingleKoma(Drawable d, int x, int y, int type);

void CreateDai(int x, int y, Dai *dai);
void DrawDai(Dai *dai, Pos pos, int mode);	/* mode != 0 : draw rect */
void ExposeDai(Dai *dai);
void MapDai(Dai *dai);

void CreateLife(int x, int y, Life *life);
void MapLife(Life *life);
void ExposeLife(Life *life);

void CreateCtrl(int x, int y, Ctrl *ctrl);
void MapCtrl(Ctrl *ctrl, int ctrlmode);

#endif
