#include <stdio.h>
#include <assert.h>

#include "all.h"
#include "canmove.h"

#define	MIN(A, B)	((A) < (B) ? (A) : (B))
#define	MAX(A, B)	((A) > (B) ? (A) : (B))
#define	DIF(A, B)	((A) > (B) ? (A) - (B) : (B) - (A))

int canmove(int teban, unsigned char bandata[9][9], unsigned char daidata[7],
			int pastpos, int nowpos, int komatype)
{
	int movetype;
	
	int canpromote 	= 	0;			/*	can							2
										can't						0	*/
	int past_x 		= 	pastpos % 9;
	int past_y 		= 	pastpos / 9;
	int now_x 		=	nowpos % 9;
	int now_y 		=	nowpos / 9;
	
	if(pastpos < 81)
	{
		movetype = MOVE;
	}
	else
	{
		movetype = DROP;
	}

	if(bandata[now_y][now_x] != EMPTY)
	{
		return 0;
	}

	if(movetype == DROP)
	{
		if(komatype == GIN	 	||
		   komatype == KIN	 	||
		   komatype == KAKU 	||
		   komatype == HISHA	)
		{
			return 1;
		}
		
		if(komatype == FU)
		{
			int i;

			for(i = 0; i < 9; i++)
			{
				if(bandata[i][now_x] == FU)
				{
					return 0;
				}
			}
		}

		if(teban == GOTE)
		{
			now_x = 8 - now_x;
			now_y = 8 - now_y;
		}
		else if(teban != SENTE)
		{
			return 0;
		}

		if(komatype == FU)
		{
			if(now_y == 0)
			{
				return 0;
			}
			else if(now_y > 0 && now_y < 9)
			{
				return 1;
			}
		}

		if(komatype == KYOSHA)
		{
			if(now_y == 0)
			{
				return 0;
			}
			else if(now_y > 0 && now_y < 9)
			{
				return 1;
			}
		}

		if(komatype == KEIMA)
		{
			if(now_y >= 0 && now_y <= 1)
			{
				return 0;
			}
			else if(now_y > 1 && now_y < 9)
			{
				return 1;
			}
		}

		return 0;
	}	

	if(movetype == MOVE)
	{
		if((past_x == now_x) && (past_y == now_y))
		{
			return 0;
		}
		
		if(komatype == HISHA)
		{
			int i;

			if(past_x == now_x)
			{
				for(i = MIN(past_y, now_y) + 1; i < MAX(past_y, now_y); i++)
				{
					if(bandata[i][now_x] != EMPTY)
					{
						return 0;
					}
				}
			}

			if(past_y == now_y)
			{
				for(i = MIN(past_x, now_x) + 1; i < MAX(past_x, now_x); i++)
				{
					if(bandata[now_y][i] != EMPTY)
					{
						return 0;
					}
				}
			}
			
			if((past_x != now_x) && (past_y != now_y))
			{
				return 0;
			}
		}
			
		if(komatype == KAKU)
		{
			int i;
			int sign_x;
			int sign_y;

			sign_x = (past_x < now_x) ? 1 : (-1);
			sign_y = (past_y < now_y) ? 1 : (-1); 

			if((MAX(past_x, now_x) - MIN(past_x, now_x))
			   != (MAX(past_y, now_y) - MIN(past_y, now_y)))
			{
				return 0;
			}
			else
			{
				for(i = 1; i < (MAX(past_x, now_x) - MIN(past_x, now_x)); i++)
				{
					if(bandata[past_y + i * sign_y]
					   		  [past_x + i * sign_x] != EMPTY)
					{
						return 0;
					}
				}
			}
		}

		if(komatype == RYU)
		{
			int i;

			if(past_x == now_x)
			{
				for(i = MIN(past_y, now_y) + 1; i < MAX(past_y, now_y); i++)
				{
					if(bandata[i][now_x] != EMPTY)
					{
						return 0;
					}
				}
			}

			if(past_y == now_y)
			{
				for(i = MIN(past_x, now_x) + 1; i < MAX(past_x, now_x); i++)
				{
					if(bandata[now_y][i] != EMPTY)
					{
						return 0;
					}
				}
			}
			
			if((past_x != now_x) && (past_y != now_y))
			{
				if((MAX(past_x, now_x) - MIN(past_x, now_x)) > 1)
				{
					return 0;
				}
				if((MAX(past_y, now_y) - MIN(past_y, now_y)) > 1)
				{
					return 0;
				}
			}
		}
			
		if(komatype == UMA)
		{
			int i;
			int sign_x;
			int sign_y;

			sign_x = (past_x < now_x) ? 1 : (-1);
			sign_y = (past_y < now_y) ? 1 : (-1); 

			if((MAX(past_x, now_x) - MIN(past_x, now_x))
			   != (MAX(past_y, now_y) - MIN(past_y, now_y)))
			{
				if((MAX(past_x, now_x) - MIN(past_x, now_x)) > 1)
				{
					return 0;
				}
				if((MAX(past_y, now_y) - MIN(past_y, now_y)) > 1)
				{
					return 0;
				}
			}
			else
			{
				for(i = 1; i < (MAX(past_x, now_x) - MIN(past_x, now_x)); i++)
				{
					if(bandata[past_y + i * sign_y]
					   		  [past_x + i * sign_x] != EMPTY)
					{
						return 0;
					}
				}
			}
		}
		
		if(komatype == KYOSHA)
		{
			int i;
			
			if(past_x != now_x)
			{
				return 0;
			}

			if(past_x == now_x)
			{
				for(i = MIN(past_y, now_y) + 1; i < MAX(past_y, now_y); i++)
				{
					if(bandata[i][now_x] != EMPTY)
					{
						return 0;
					}
				}
			}

			if(teban == GOTE)
			{
				if(8 - past_y <= 8 - now_y)
				{
					return 0;
				}
			}

			if(teban == SENTE)
			{
				if(past_y <= now_y)
				{
					return 0;
				}
			}
		}
			
		if(teban == GOTE)
		{
			past_x = 8 - past_x;
			past_y = 8 - past_y;
			now_x = 8 - now_x;
			now_y = 8 - now_y;
		}

		if(komatype == FU		||
		   komatype == KYOSHA	||
		   komatype == KEIMA	||
		   komatype == GIN		||
		   komatype == KAKU		||
		   komatype == HISHA	)
		{
			if((now_y < 3) || (past_y < 3))
			{
				canpromote = 2;
			}
		}

		if(komatype == FU)
		{
			if(now_x != past_x)
			{
				return 0;
			}

			if(past_y - now_y != 1)
			{
				return 0;
			}

			if(now_y == 0)
			{
				return canpromote;
			}
			else
			{
				return canpromote + 1;
			}
		}

		if(komatype == KYOSHA)
		{
			if(now_y == 0)
			{
				return canpromote;
			}
			else
			{
				return canpromote + 1;
			}
		}

		if(komatype == KEIMA)
		{
			if(past_y - now_y != 2)
			{
				return 0;
			}

			if(MAX(past_x, now_x) - MIN(past_x, now_x) != 1)
			{
				return 0;
			}
			
			if(now_y <= 1)
			{
				return canpromote;
			}
			else
			{
				return canpromote + 1;
			}
		}
		
		if(komatype == GIN)
		{
			if(now_y == past_y - 1)
			{
				if(MAX(past_x, now_x) - MIN(past_x, now_x) > 1)
				{
					return 0;
				}
			}
			else if(now_y == past_y + 1)
			{
				if(MAX(past_x, now_x) - MIN(past_x, now_x) != 1)
				{
					return 0;
				}
			}
			else
			{
				return 0;
			}
			
			return canpromote + 1;
		}

		if(komatype == KIN		||
		   komatype == TO		||
		   komatype == NKYO		||
		   komatype == NKEI		||
		   komatype == NGIN		)
		{
			if(now_y == past_y - 1)
			{
				if(MAX(past_x, now_x) - MIN(past_x, now_x) > 1)
				{
					return 0;
				}
			}
			else if(now_y == past_y)
			{
				if(MAX(past_x, now_x) - MIN(past_x, now_x) != 1)
				{
					return 0;
				}
			}
			else if(now_y == past_y + 1)
			{
				if(MAX(past_x, now_x) - MIN(past_x, now_x) != 0)
				{
					return 0;
				}
			}
			else
			{
				return 0;
			}
			
			return canpromote + 1;			
		}

		if(komatype == OU)
		{
			if(MAX(past_x, now_x) - MIN(past_x, now_x) > 1)
			{
				return 0;
			}

			if(MAX(past_y, now_y) - MIN(past_y, now_y) > 1)
			{
				return 0;
			}
			
			return canpromote + 1;			
		}

		if(komatype == KAKU)
		{
			return canpromote + 1;			
		}

		if(komatype == HISHA)
		{
			return canpromote + 1;			
		}

		if(komatype == UMA)
		{
			return canpromote + 1;			
		}

		if(komatype == RYU)
		{
			return canpromote + 1;			
		}

		return 0;
	}
	
	return 0;
}

int TuIsAbleToMove(bandata, sx, sy, dx, dy, koma)
    unsigned char bandata[][9];
    int sx, sy;
    int dx, dy;
    unsigned char koma;
{
    int x, y;
    int isx, isy;
    int idx, idy;

    if( sx == dx && sy == dy )
	return 0;

    if( koma & TuSideMask ) {	/* ʤɸȿž */
	isx = 8 - sx;	isy = 8 - sy;
	idx = 8 - dx;	idy = 8 - dy;
	koma &= ~TuSideMask;
    }
    else {
	isx = sx;	isy = sy;
	idx = dx;	idy = dy;
    }

    switch( koma ) {

    case RYU:
	if( DIF(sx, dx) == 1 && DIF(sy, dy) == 1 )
	    break;
	/*  */
    case HISHA:
	if( sx == dx )
	    for( y = MIN(sy, dy) + 1 ; y < MAX(sy, dy) ; y++ )
		if( bandata[y][dx] != EMPTY )
		    return 0;
	else if( sy == dy )
	    for( x = MIN(sx, dx) + 1 ; x < MAX(sx, dy) ; y++ )
		if( bandata[dy][x] != EMPTY )
		    return 0;
	else
	    return 0;
	break;

    case UMA:
	if( sx == dx && DIF(sy, dy) == 1 )
	    break;
	if( DIF(sx, dx) == 1 && sy == dy )
	    break;
	/*  */
    case KAKU:
	if( DIF(sx, dx) != DIF(sy, dy) )
	    return 0;
	else {
	    int x1;
	    int y_sign;

	    if( sx < dx ) {
		x = sx;
		y = sy;
		x1 = dx;
		y_sign = sy < dy ? +1 : -1;
	    }
	    else {
		x = dx;
		y = dy;
		x1 = sx;
		y_sign = dy < sy ? +1 : -1;
	    }
	    for( x++ ; x < x1 ; x++ ) {
		y += y_sign;
		if( bandata[y][x] != EMPTY)
		    return 0;
	    }
	}
	break;

    case KYOSHA:
	if( sx != dx || isy <= idy )
	    return 0;

	for( y = MIN(sy, dy) + 1; y < MAX(sy, dy); y++ )
	    if( bandata[y][dx] != EMPTY )
		return 0;
	break;

    case FU:
	if( sx != dx || isy != idy + 1 )
	    return 0;
	break;

    case KEIMA:
	if( isy != idy + 2 || DIF(sx, dx) != 1 )
	    return 0;
	break;

    case GIN:
	if( idy == isy - 1 && sx - 1 <= dx && dx <= sx + 1 )
	    break;
	if( idy == isy + 1 && sx - 1 == dx && dx == sx + 1 )
	    break;
	return 0;

    case KIN:
    case TO:
    case NKYO:
    case NKEI:
    case NGIN:
	if( idy == isy - 1 && sx - 1 <= dx && dx <= sx + 1 )
	    break;
	if( idy == isy   && (sx - 1 == dx || dx == sx + 1) )
	    break;
	if( idy == isy + 1 && sx == dx )
	    break;
	return 0;

    case OU:
	if( DIF(sx, dx) <= 1 && DIF(sy, dy) <= 1 )
	    break;
	return 0;

    default:
	return 0;
    }
    return 1;
}

int TuIsAbleToDrop(bandata, dx, dy, koma)
    unsigned char bandata[][9];
    int dx, dy;
    unsigned char koma;
{
    int y;

    assert(FU <= (koma & ~TuSideMask) && (koma & ~TuSideMask) < OU);

    switch( koma & ~TuSideMask ) {

    case FU:
	for( y = 0; y < 9; y++ )
	    if( y != dy && bandata[y][dx] == koma )
		return 0;	/*  */
	/*  */
    case KYOSHA:
	if( koma & TuSideMask ) {
	    if( dy == 8 )
		return 0;	/* ˶ */
	}
	else {
	    if( dy == 0 )
		return 0;	/* ˶ */
	}
	break;
    case KEIMA:
	if( koma & TuSideMask ) {
	    if( dy >= 7 )
		return 0;	/* ˶ */
	}
	else {
	    if( dy <= 1 )
		return 0;	/* ˶ */
	}
	break;
    }

    return 1;
}

int TuIsAbleToPromote(x, y, koma)
    int x, y;
    unsigned char koma;
{
    if( koma & TuPromotionMask )
	return 0;	/* ǤäƤ */

    switch( koma & ~TuSideMask ) {
    case KIN:
    case OU:
	break;
    default:
	if( koma & TuSideMask ) {
	    if( y >= 6 )
		return 1;
	}
	else
	    if( y <= 2 )
		return 1;
    }
    return 0;
}
