/*
 *	cursor.c	X-Tuitate cursor control
 *
 * ProvideCursors( )	- provide necessary cursors.
 * SetCursor( )		- set a cursor to the window.
 */

#include <stdio.h>

#include <X11/Xlib.h>
#include <X11/cursorfont.h>

#include "all.h"
#include "cursor.h"

static Cursor cursor[CSR_NCURSOR];

static int cursor_shapes[CSR_NCURSOR] = {
	XC_left_ptr	/* NORMAL	*/,
	XC_watch	/* WAITING	*/
};

void ProvideCursors( )
{
    int i;

    for( i = 0 ; i < CSR_NCURSOR ; i++ ) {
	cursor[i] = XCreateFontCursor(xdata.display, cursor_shapes[i]);
	switch( cursor[i] ) {
	case BadAlloc:
	    fprintf(stderr,
		    "%s: fatal error: failed to allocate cursor resource"
		    " or server memory\n",
		    myname);
	    exit(1);
	case BadValue:
	    fprintf(stderr,
		    "%s: FATAL ERROR: XCreateFontCursor() returned BadValue\n",
		    myname);
	    abort( );
	}
    }
}

void SetCursor(window, shape)
    Window window;
    int shape;
{
    XDefineCursor(xdata.display, window, cursor[shape]);
    XFlush(xdata.display);
}
