
#include <stdio.h>

#include <X11/Xlib.h>
#include <X11/Xutil.h>

#include "config.h"

#include "all.h"
#include "xdata.h"
#include "title.h"
#include "xmisc.h"
#include "resource.h"

#include "bitmaps/kmc.xbm"

Pixmap kmc_logo;

/*
 *  XTuitate initial title (a logo of KMC)
 */
void initial_title(void)
{
    GC gc;
    XGCValues gcv;
    int x, y;
    XEvent event;

    kmc_logo = XCreateBitmapFromData(xdata.display, win.id,
				     kmc_bits, kmc_width, kmc_height);

    if( kmc_logo == None ) {
	fprintf(stderr, "No memory for bitmap\n");
	exit(1);
    }

    gcv.clip_mask = kmc_logo;
    gcv.clip_x_origin = x = (WIN_WIDTH - kmc_width) / 2;
    gcv.clip_y_origin = y = (WIN_HEIGHT - kmc_height) / 2;
    gcv.foreground = foregroundPixel();
    gc = XCreateGC(xdata.display, win.id,
		   GCForeground|GCClipXOrigin|GCClipYOrigin|GCClipMask, &gcv);
    /*
     * Wait for Expose event
     * If this wait is omitted, sometimes graphics will not be drawn.
     */
    do {
	XNextEvent(xdata.display, &event);
    } while( event.type != Expose || event.xexpose.count != 0 );
    XFillRectangle(xdata.display, win.id, gc, x, y, kmc_width, kmc_height);
    XFlush(xdata.display);
    XFreeGC(xdata.display, gc);
}
