/*
 *	token.c			X-Tuitate TUP token lexical analizer
 */

#include <stdio.h>

#include "all.h"

static char *tokentable[ ] = {
#define	TOKEN_H_STRINGDEFS
#include "token.h"
    NULL
};

unsigned long token_value;

int get_decimal_token(ptr)
    char **ptr;
{
    char *p = *ptr;
    int value;

    while( *p == ' ' || *p == '\t' ) p++;

    if( *p < '0' || '9' < *p ) {
	fprintf(stderr, "%s: Can't fetch decimal: \"%s\"\n", myname, p);
	abort( );
    }
    value = 0;
    do {
	value = value * 10 + (*p++ - '0');
    } while( '0' <= *p && *p <= '9' );
    if( *p && *p != ' ' && *p != '\n' && *p != '\t' ) {
	fprintf(stderr, "%s: Invalid caracter: \"%s\"\n", myname, p);
	abort( );
    }
    *ptr = p;
    return value;
}

int TuParseToken(ptr)
    char **ptr;
{
    char *p = *ptr;
    int low = 0;
    int high = sizeof(tokentable) / sizeof(char *) - 2;
    int middle;
    char *p1, *p2;

    while( *p == ' ' || *p == '\t' ) p++;

    if( !*p )
	return 0;

    if( '0' <= *p && *p <= '9' ) {
	token_value = 0;
	do {
	    token_value = token_value * 10 + (*p++ - '0');
	} while( '0' <= *p && *p <= '9' );
	if( *p && *p != ' ' && *p != '\n' && *p != '\t' )
	    return -2;
	*ptr = p;
	return -1;
    }

    do {
	middle = (low + high) / 2;

	p1 = p, p2 = tokentable[middle];

	while( 1 ) {
	    if( !*p2 && (!*p1 || *p1 == ' ' || *p1 == '\n' || *p1 == '\t') ) {
		*ptr = p1;
		return middle + 1;
	    }
	    if( *p1 != *p2 ) break;
	    p1++;
	    p2++;
	}
	if( (unsigned char)*p1 > (unsigned char)*p2 )
	    low = middle + 1;
	else
	    high = middle - 1;
    } while( low <= high );

    return -2;
}
    
#if 0
const char *tuitateKomaToString(koma)
    int koma;
{
    switch( koma ) {
    case TPAWN:
	return "";
    case TLANCE:
	return "";
    case TKNIGHT:
	return "";
    case TSILVER:
	return "";
    case TGOLD:
	return "";
    case TBISHOP:
	return "";
    case TROOK:
	return "";
    case TKING:
	return "";
    }
    return "";
}
#endif
