/*
 *	TUITATE Protocol 0.4.0	Header
 */

#ifndef	TUITATE_H
#define	TUITATE_H

#if 0
typedef	struct {
	int type;
	int send_message;
} TuitateAny;

typedef	struct {
	int type;
	int send_message;
	char *name;
	char *mailaddress;
} TuitateGame;

typedef	struct {
	int type;
	int send_message;
	int number_of_clients;
} TuitateChallengerList;

typedef	struct {
	int type;
	int send_message;
	int client;
} TuitateChallenge;

typedef	struct {
	int type;
	int send_message;
} TuitateAccept;

typedef struct {
	int type;
	int send_message;
} TuitateRefuse;

typedef struct {
	int type;
	int send_message;
	int client;
	char *name;
	char *mailaddress;
} TuitateChallenged;

typedef struct {
	int type;
	int send_message;
	int side;
} TuitateStart;

typedef	struct {
	int type;	/* TUITATE_MOVE */
	int send_message;
	int sx, sy;	/* ưɸ */
	int dx, dy;	/* ưɸ */
	int promotion;
	int checked;
	int piece;
	int p_promotion;
	int violation;
} TuitateMove;

typedef	struct {
	int type;	/* TUITATE_DROP */
	int send_message;
	int dx, dy;
	int piece;
	int checked;
	int violation;
} TuitateDrop;

typedef	struct {
	int type;	/* TUITATE_OK */
	int send_message;
	int piece;
	int check;
} TuitateOk;

typedef	struct {
	int type;
	int send_message;
} TuitateIllegal;

typedef	struct {
	int type;
	int send_message;
	int violation;
} TuitateViolate;

typedef struct {
	int type;	/* TUITATE_NEXT */
	int send_message;
	int x, y;
	int checked;
} TuitateNext;

typedef	TuitateAny	TuitateEnemyViolate;
typedef	TuitateAny	TuitateGiveup;

typedef	struct {
	int type;	/* TUITATE_END */
	int send_message;
	int result;
	int reason;
	int ndata;
	int winner;
} TuitateEnd;

typedef	struct {
	unsigned int id;
	time_t begin;
	time_t end;
	TuitateUser black;
	TuitateUser white;
} TuitateNotationListElement;

typedef	struct {
	int type;
	int send_message;
	int ndata;
	TuitateNotationListElement *list;
} TuitateNotationList;

typedef	struct {
	int type;	/* TUITATE_NOTATION */
	int send_message;
	int ndata;
	TuitateItte *list;
	int winner;
	int reason_of_end;
} TuitateNotation;

typedef	TuitateAny	TuitateNotExist;
typedef	TuitateAny	TuitateQuit;

typedef	union {
	int			type;
	TuitateGame		game;
	TuitateChallengerList	challengerlist;
	TuitateChallenge	challenge;
	TuitateAccept		accept;
	TuitateRefuse		refuse;
	TuitateChallenged	challenged;
	TuitateNotExist		notexist;
} TuitateMessage;
#endif

#include <limits.h>

#include "token.h"

#if	TLASTTOKEN <= CHAR_MAX
typedef	char	TuToken;
#elif	TLASTTOKEN <= SHRT_MAX
typedef	short	TuToken;
#elif	TLASTTOKEN <= INT_MAX
typedef	int	TuToken;
#else
typedef	long	TuToken;
#endif

int TuParseToken(char **);
int get_decimal_token(char **);

extern unsigned long token_value;

typedef	struct {
	TuToken		type;		/* TMOVE or TDROP */
	unsigned char	sx, sy;
	unsigned char	dx, dy;
	TuToken		piece;
	TuToken		violation;
	unsigned char	flags;
} TuNotationMove;

typedef	struct {
	TuNotationMove *	move;
	unsigned int		current;
	unsigned int		count;
	size_t			nmove;
	size_t			nalloc;
	unsigned char		flags;
	TuToken			winner;
	TuToken			reason;
} TuNotation;

void TuInitializeNotation(TuNotation *);
int TuGetOneMove(TuNotation *);
int TuGetNotation(size_t, TuNotation *);
void TuFreeNotation(TuNotation *);
int TuTokenToKoma(TuToken);
void TuNotationPatch(TuNotationMove *, unsigned char[][9],
		     unsigned char[][8], int []);
void TuNotationRevPatch(TuNotationMove *,
			unsigned char[][9], unsigned char[][8], int []);
extern TuNotation notation;

#define	TuCheckedMask	0x01
#define	TuDoMask	0x02
#define	TuEndMask	0x04
/*	TuPromotionMask	0x08 */
/*	TuSideMask	0x10 */
/*	TuExistMask	0x20 */

#ifndef	SEEK_SET
#define	SEEK_SET 0
#define	SEEK_CUR 1
#define	SEEK_END 2
#endif

#endif	/* !TUITATE_H */
