#if !defined(XDATA_H)
#define XDATA_H

#include <X11/Xlib.h>

#define MAX_GCSET		16

#if 0
		GCSet[0]  : black
		GCSet[1]  : blue
		GCSet[2]  : red
		GCSet[3]  : purple
		GCSet[4]  : green
		GCSet[5]  : cyan
		GCSet[6]  : yellow
		GCSet[7]  : white
		GCSet[8]  : not defined
		GCSet[9]  : not defined
		GCSet[10] : not defined
		GCSet[11] : not defined
		GCSet[12] : not defined
		GCSet[13] : not defined
		GCSet[14] : not defined
		GCSet[15] : not defined
#endif

typedef struct gcset_tag
{
	GC type[MAX_GCSET];
} GCSet;

typedef struct windata_tag
{
	Window id;
	Window parent;
	int x, y;
	unsigned int width, height;
	unsigned int bw;
	unsigned long fg;
	unsigned long bg;
} Windata;

typedef struct xdata_tag
{
	Display *display;
	int screen;
	Windata root;
	GC gc;
	Visual *visual;
	Colormap cmap;
	int depth;
} Xdata;

Xdata ConstructXdata(char *displayname);

void ConstructWindata(Xdata *xdata, Window parent,
                         int x, int y,
                         unsigned int width, unsigned int height,
                         unsigned int bw,
                         unsigned long fg, unsigned long bg,
                         int over, Windata *win);

void CopyWindata(Xdata *xdata, Windata *dist, Windata *src);
void MakeSizeHints(Xdata *, Windata *, char *, char *,
		   Pixmap, int, char **);
void MakeClassHint(Xdata *, Windata *, char *, char *);

void InitGCSet(Xdata *xdata, GCSet *gcset);
void RegistGCSet(Xdata *xdata, GCSet *gcset,
				 int red, int green, int blue, int num);
void RegistGCSetNamed(Xdata *xdata, GCSet *gcset, char *colname, int num);

#endif
