#if !defined(XTOOL_H)
#define XTOOL_H

#include "xdata.h"

/* for xinput */
#define INPUTWIN_WIDTH		320
#define INPUTWIN_HEIGHT		100

/* for xbutton */
#define BUTTON_ENTER	1
#define BUTTON_LEAVE	0

/* for xaskwin */
#define MESGLEN			32		/* max length of Askwin.mesg */
#define ASKWIN_WIDTH	128
#define ASKWIN_HEIGHT	96

/* for mesg */
#define MESG_WIDTH				256
#define MESG_HEIGHT				150
#define MESG_LINE				4
#define MESG_OFFSET_X			8
#define MESG_OFFSET_Y			36
#define MESG_LINE_HEIGHT		32

typedef struct
{
    Windata win;
    GCSet gcset;
    char text[MESG_LINE][64];
    int color[MESG_LINE];
} Mesg;

typedef struct
{
    Windata win;
    Pixmap pm;
} Button;

typedef struct
{
    Windata win;
    Button yes;
    Button no;
    Pixmap pm;
} Askwin;

void InputWin(Xdata *xdata, Windata *parent,
	      int x, int y, char *title, char *ret);

#define ButtonId(b)		((b).win.id)
void ExposeButton(Xdata *xdata, Button *button);
void FocusButton(Xdata *xdata, Button *button, int mode);
void MapButton(Xdata *xdata, Button *button);
void UnmapButton(Xdata *xdata, Button *button);
void CreateButton(Xdata *xdata, Windata *win,
    Pixmap button_pixmap, Pixmap button_f_pixmap,
    int x, int y, int width, int height, int bw, Button *button);

#define AskwinId(a)		((a).win.id)
#define AskwinYesId(a)	((a).yes.win.id)
#define AskwinNoId(a)	((a).no.win.id)
void MapAskwin(Xdata *xdata, Askwin *askwin);
void UnmapAskwin(Xdata *xdata, Askwin *askwin);
void MoveAskwin(Xdata *xdata, Askwin *askwin, Windata *parent);
void CreateAskwin(Xdata *xdata, Windata *win, char *mesg,
		    int x, int y, Askwin *askwin);
void DestroyAskwin(Xdata *xdata, Askwin *askwin);

void CreateMesg(Xdata *xdata, Windata *win, int x, int y, Mesg *mesg);
void InitMesgText(Mesg *mesg);
void MapMesg(Xdata *xdata, Mesg *mesg);
void UnmapMesg(Xdata *xdata, Mesg *mesg);
void ExposeMesg(Xdata *xdata, Mesg *mesg);
void SetMesgText(Mesg *mesg, int line, char *text, int color);

void SetMesgTextF(Mesg *mesg, int line, int color, const char *fmt, ...)
#ifdef	__GNUC__
#if __GNUC__ > 2 || (__GNUC__ == 2 && __GNUC_MINOR__ >= 5)
	__attribute__((format (printf, 4, 0)))
#endif
#endif
;
	
typedef	union {
	Window	w;
	int	i;
	unsigned int u;
} Junk;

#endif	/* !XTOOL_H */
